Subject: Re: [PATCH 1/4] Net device error logging, revised

From: Jeff Garzik <[email-masked]>
Date: Wed, 03 Sep 2003 13:32:00 -0400

Jim Keniston wrote:
> Jeff Garzik wrote:
>>"NETIF_MSG_" is silly and should be eliminated.
> 
> 
>>>From this, I infer that you think that the option to "omit" the msglevel arg --
> e.g.,
> 	netdev_err(dev,, "NIC is fried!\n");	/* always logged */
> -- is silly.  No big deal.  Its sole purpose is to help keep netdev_* calls terse.

yes

>>A separate "NETIF_MSG_ALL" test is not needed, because msg_enable is a
>>bitmask.  A msg_enable of 0xffffffff will naturally create a NETIF_MSG_ALL.
> 
> 
> But how do you code a netdev_* call where you ALWAYS want the message (including
> netdev_printk-style prefix) logged, regardless of the value of msg_enable?  That's
> what NETIF_MSG_ALL is for (and why it might be better called NETIF_MSG_ALWAYS)...

I understand the purpose of NETIF_MSG_ALL; re-read what I said.  You 
don't need a separate _test_, as your implementation includes.  Defining 
NETIF_MSG_ALL to 0xffffffff will naturally create the effect you seek.

>>Also, whatever mechanism is created, it needs to preserve the feature of
>>the existing system:
>>
>>        if (a quick bitmask test)
>>                do something
>>
>>And preferably "do something" is not inlined, because printk'ing --
>>although it may appear in a fast path during debugging -- cannot be
>>considered a fast path itself.

> Sorry, I'm not sure what you're getting at here.  netdev_* doesn't prevent
> people from using the existing netif_msg_* macros; it just provides shorthand
> for the (usual) case where "do something" is "printk".

I would prefer to be more ambitious.  If we're gonna go in and change 
every printk in a driver, we might as well do it right, and (a) make 
sure the driver does msg_enable, and (b) make the source code a bit more 
clean by hiding the "if (test bitmap)" test in your netdev_xxx stuff.

	Jeff